<?php declare(strict_types=1);

namespace nogueiracodes\RaspberryBot\Bot\Commands;

use Analog\Analog;
use Exception;
use nogueiracodes\RaspberryBot\Bot\Helpers\CatAPI;
use nogueiracodes\RaspberryBot\Core\Interfaces\Command;
use nogueiracodes\RaspberryBot\Traits\HasSignature;

class Gimme implements Command
{
    use HasSignature;

    public $signature = "gimme {thing: What to give you} {quantity: How many cat pictures}";


    private $cats;


    public function __construct()
    {
        $this->cats = new CatAPI();
        Analog::info('Commands: Loaded Gimme!');
    }

    public function run(array $parameters)
    {
        Analog::debug('Gimme: Nr of args: ' . count($parameters));



        Analog::debug('Gimme: Thing: ' . $parameters['thing'] ?? 'unset');
        Analog::debug('Gimme: Count: ' . $parameters['quantity'] ?? 'unset');
        Analog::debug('Gimme: Raw parameter contents: ', json_encode($parameters));

        if ($parameters['quantity'] > 25)
        {
            throw new Exception('Sorry, but I can\'t send you more than 25 cat pictures at a time. What a cat lover!');   
        }

        switch($parameters['thing']) {

            case "cat":
                
                
                try 
                {
                    // Many pictures will return a list of pictures, separated by new lines
                    return $this->cats->getCatPicture($parameters['what'], "small");
                } 
                catch (Exception $ex)
                {
                    throw $ex; // Let the bot handle this. It sends error messages as responses to keep things clean.
                }

                break;
            default:
            
                throw new Exception("Uh oh. I don\'t know what you mean by " . $parameters['what'] . " Maybe try ? help?");

            break;

        }
    }
}